// Verilog model  - Wed Oct 27 09:30:09 2004

`timescale 1ns / 1ps

module vme_ctrlr(CLK, RST, DATA_IN, FF_ODV, FF_RHOLD, FF_HAS_DATA, FF_RD_ERR, FLSHD, IN_CTRL_CODE,
      MSTR_BUSY, MSTR_DAV, MSTR_WRT_RDB, MSTR_AM, MSTR_TT, MSTR_DATA_SZ, MSTR_ERR, MSTR_ERR_REG,
      NEXT_WRD, MSTR_FADDR, RSLT_DATA, IH_ERR, IH_WARN, IH_ERR_REG, IH_DT_SZ, IH_IRQ, IH_A, IH_BUSY, IH_DAV,
      RB_BG_VMEW, FB_BG_VMEW, TB_BG_VMEW, TB_BG_VMER, VMER_OE, SW2,
      ACKN, VRD_IDLE, DATA_OUT,
      EXECUTE, FF_READ, AD_MOD, FULL_ADDR, FULL_DATA, LAST_WORD, NEXT_RDY, VMEW_BR, VMER_BR, RFUNCT,
      TXTYPE, NORM_DAT, PRIO_DAT, SPONT_DAT, SEND_NORM, SEND_PRIO, SEND_SPONT,
      ADDR_SZ, DATA_SZ, TRNS_TYP, DLY_TYP, WRT_RDB, CLR_MSTR_ERR, TEST_A, TEST_B, TEST_C);

    input CLK;
    input RST;
    input [15:0] DATA_IN;
    input FF_ODV;
    input FF_RHOLD;
    input FF_HAS_DATA;
    input FF_RD_ERR;
    input FLSHD;
    input [2:0] IN_CTRL_CODE;
    input MSTR_BUSY;
    input MSTR_DAV;
    input MSTR_WRT_RDB;
    input [5:0] MSTR_AM;
    input [1:0] MSTR_TT;
    input [1:0] MSTR_DATA_SZ;
    input MSTR_ERR;
    input [7:0] MSTR_ERR_REG;
    input NEXT_WRD;
    input [63:0] MSTR_FADDR;
    input [63:0] RSLT_DATA;
    input IH_ERR;
    input IH_WARN;
    input [7:0] IH_ERR_REG;
    input [1:0] IH_DT_SZ;
    input [7:1] IH_IRQ;
    input [3:1] IH_A;
    input IH_BUSY;
    input IH_DAV;
    input RB_BG_VMEW;
    input FB_BG_VMEW;
    input TB_BG_VMEW;
    input TB_BG_VMER;
    input VMER_OE;
    input [3:0] SW2;
   output [3:0] ACKN;
   output VRD_IDLE;
   output [15:0] DATA_OUT;
   output EXECUTE;
   output FF_READ;
   output [5:0] AD_MOD;
   output [63:0] FULL_ADDR;
   output [63:0] FULL_DATA;
   output LAST_WORD;
   output NEXT_RDY;
   output [1:0] VMEW_BR;
   output VMER_BR;
   output [2:0] RFUNCT;
   output [7:0] TXTYPE;
   output NORM_DAT;
   output PRIO_DAT;
   output SPONT_DAT;
   output SEND_NORM;
   output SEND_PRIO;
   output SEND_SPONT;
   output [2:0] ADDR_SZ;
   output [1:0] DATA_SZ;
   output [1:0] TRNS_TYP;
   output [2:0] DLY_TYP;
   output WRT_RDB;
   output CLR_MSTR_ERR;
   output [15:0] TEST_A;
   output [15:0] TEST_B;
   output [15:0] TEST_C;

reg [15:0] TEST_A;
reg [15:0] TEST_B;
reg [15:0] TEST_C;

reg [5:0] VWRT_ST;
reg [4:0] VFFW_ST;
reg [2:0] VFFR_ST;
reg [2:0] RFUNCT;
reg LOAD_TYPE;
reg WRT_RDB;
reg [1:0] DATA_SZ;
reg [2:0] ADDR_SZ;
reg [1:0] TRNS_TYP;
reg [4:0] ACCS_TYP;
reg [2:0] DLY_TYP;
reg [5:0] AD_MOD;
reg [5:0] UD_AM;
reg [63:0] FULL_ADDR;
reg [63:0] FULL_DATA;
reg FF_READ;
reg LOAD_UNITS;
reg DEC_UNITS;
reg [15:0] UNITS;
reg LOAD_DCNT;
reg DEC_DCNT;
reg [15:0] DCNT;
reg PUSH;
reg POP;
reg V_POP;
reg VFF_CE;
reg VFF_DIR;
reg [63:0] DATA_REG;
reg LOAD_DATA_REG;
reg [3:0] RSPD;
reg [3:0] ACKN;
reg [5:0] ACKN_MSK;
reg LD_ACKN;
wire RST_ACKN;
reg [2:0] DATA_SIZE;
reg ANY_DATA;
reg CLR_ANY_DATA;
reg RD_CMPLT;
reg SEND;
reg SENT;
reg SET_EOP;
reg SET_VLDT;
reg  [2:0] PKT_TYP;
reg  [2:0] PKT_TYP_WR;
wire [2:0] PKT_TYP_RD;
reg  [2:0] SEND_PKT_TYP;
reg EOP;
reg EOP_WR;
reg VLDT;
wire EOP_RD;
wire VLDT_RD;
reg VRD_IDLE;
reg [15:0] DATA_OUT;
reg [15:0] VFF_IN;
reg [15:0] MER_REG;
reg [15:0] VSTATE_REG;
reg [7:0] TXTYPE;
reg NORM_DAT;
reg PRIO_DAT;
reg SPONT_DAT;
reg SEND_PKT;
reg SEND_NORM;
reg SEND_PRIO;
reg SEND_SPONT;
reg VD1;
reg [1:0] VMEW_BR;
reg VMER_BR;
reg BG_VMEW;
reg EXECUTE;   
reg BIP;
reg SET_BIP;
reg RST_BIP;
reg CLR_MSTR_ERR;
reg UAM;
reg PRG;
reg NEXT_RDY;
reg [2:0]FTCH_WRDS;
reg FF_ODV_D1;
reg FF_ODV_D2;
reg FF_ODV_D3;
reg FF_ODV_D4;
reg FF_ODV_D5;
reg ADDR_PHASE;
reg DATA_PHASE;
reg AM_CAP;
reg CTRL_ERR;
reg [3:0] CTRL_ERR_REG;


wire ANY_DAV;
wire ANY_MSG;
wire FFODV1;
wire FFODV2;
wire FFODV3;
wire FFODV4;
wire FFODV5;
wire DAT_CAP;
wire LAST_UNIT;
wire LAST_WORD;
wire [15:0] VFF_OUT; 
//wire [9:0] VME_WADDR; 
//wire [9:0] VME_RADDR; 
//wire [9:0] VFF_CNT;
wire [3:0] VME_WADDR; 
wire [3:0] VME_RADDR; 
wire [3:0] VFF_CNT;
wire VFF_MT;
wire BAD_DLY;
   
`ifdef HEADER
`else
`include "header.v"
`endif


assign   VFF_MT = (VFF_CNT == 4'h0);
assign LAST_UNIT = (UNITS == 16'h0001);
assign LAST_WORD = (DCNT == 16'h0001);
assign FFODV1 = FF_ODV & !FF_ODV_D1;
assign FFODV2 = FF_ODV & FF_ODV_D1 & !FF_ODV_D2;
assign FFODV3 = FF_ODV & FF_ODV_D2 & !FF_ODV_D3;
assign FFODV4 = FF_ODV & FF_ODV_D3 & !FF_ODV_D4;
assign FFODV5 = FF_ODV & FF_ODV_D4 & !FF_ODV_D5;
assign DAT_CAP = !FF_ODV & FF_ODV_D1;

assign BAD_DLY = (DLY_TYP > 3'd6);

assign ANY_DAV = MSTR_DAV || MSTR_ERR || IH_DAV || IH_ERR || IH_WARN || CTRL_ERR; //Add  warnings, info, and interrupts
assign ANY_MSG = MSTR_ERR || IH_ERR || IH_WARN || CTRL_ERR;  //Add other errors, warnings, info
assign RST_ACKN = !(|(ACKN_MSK & {IH_ERR, MSTR_ERR, CTRL_ERR, IH_DAV, MSTR_DAV, IH_WARN}));

always @(posedge CLK)
begin
   case (SW2)
      4'h0:
         begin
            TEST_A[5:0] <= VWRT_ST[5:0];
            TEST_A[10:6] <= VFFW_ST[4:0];
            TEST_A[15:11] <= DCNT[4:0];
            TEST_B[1:0] <= DATA_SZ[1:0];
            TEST_B[4:2] <= ADDR_SZ[2:0];
            TEST_B[6:5] <= TRNS_TYP[1:0];
            TEST_B[11:7] <= ACCS_TYP[4:0];
            TEST_B[12] <= NEXT_WRD;
            TEST_B[13] <= NEXT_RDY;
            TEST_B[14] <= LAST_WORD;
            TEST_B[15] <= (ACKN == `V_Mstr_Dav);
            TEST_C[5:0] <= AD_MOD[5:0];
            TEST_C[6] <= BIP;
            TEST_C[7] <= EXECUTE;
            TEST_C[15:8] <= 8'h00; // Sourced by Master
         end
      4'h1:
         begin
            TEST_A[5:0] <= VWRT_ST[5:0];
            TEST_A[10:6] <= VFFW_ST[4:0];
            TEST_A[13:11] <= VFFR_ST[2:0];
            TEST_A[14] <= SEND;
            TEST_A[15] <= ANY_MSG;
            TEST_B[2:0] <= PKT_TYP[2:0];
            TEST_B[5:3] <= PKT_TYP_WR[2:0];
            TEST_B[8:6] <= PKT_TYP_RD[2:0];
            TEST_B[11:9] <= SEND_PKT_TYP[2:0];
            TEST_B[15:12] <= TXTYPE[3:0];
            TEST_C <= 16'h0000; // Sourced by Master
         end
      4'h2:
         begin
            TEST_A[5:0] <= VWRT_ST[5:0];
            TEST_A[10:6] <= VFFW_ST[4:0];
            TEST_A[13:11] <= VFFR_ST[2:0];
            TEST_A[14] <= SEND;
            TEST_A[15] <= ANY_MSG;
            TEST_B[2:0] <= PKT_TYP[2:0];
            TEST_B[5:3] <= PKT_TYP_WR[2:0];
            TEST_B[8:6] <= PKT_TYP_RD[2:0];
            TEST_B[11:9] <= SEND_PKT_TYP[2:0];
            TEST_B[15:12] <= TXTYPE[3:0];
            TEST_C[0] <= EOP_WR;
            TEST_C[1] <= EOP_RD;
            TEST_C[2] <= VLDT_RD;
            TEST_C[3] <= VFF_MT;
            TEST_C[4] <= NORM_DAT;
            TEST_C[5] <= SPONT_DAT;
            TEST_C[6] <= SEND_NORM;
            TEST_C[7] <= SEND_SPONT;
            TEST_C[15:8] <= 8'h00; // Sourced by Master
         end
      4'h3:
         begin
            TEST_A[5:0] <= VWRT_ST[5:0];
            TEST_A[10:6] <= VFFW_ST[4:0];
            TEST_A[13:11] <= VFFR_ST[2:0];
            TEST_A[14] <= SEND;
            TEST_A[15] <= ANY_MSG;
            TEST_B[0] <= CTRL_ERR;
            TEST_B[1] <= MSTR_ERR;
            TEST_B[2] <= ACKN_MSK[3]; //control
            TEST_B[3] <= ACKN_MSK[4]; //master
            TEST_B[7:4] <= ACKN[3:0];
            TEST_B[11:8] <= RSPD[3:0];
            TEST_B[12] <= RST_ACKN;
            TEST_B[13] <= SET_VLDT;
            TEST_B[14] <= CLR_MSTR_ERR;
            TEST_B[15] <= CLR_ANY_DATA;
            TEST_C[0] <= EOP_WR;
            TEST_C[1] <= EOP_RD;
            TEST_C[2] <= VLDT_RD;
            TEST_C[3] <= VFF_MT;
            TEST_C[4] <= NORM_DAT;
            TEST_C[5] <= SPONT_DAT;
            TEST_C[6] <= SEND_NORM;
            TEST_C[7] <= SEND_SPONT;
            TEST_C[15:8] <= 8'h00; // Sourced by Master
         end
      default:       //SW2 == 4 is used by Interrupt Handler.
         begin
            TEST_A <= 16'h0000;
            TEST_B <= 16'h0000;
            TEST_C <= 16'h0000;
         end
   endcase
end

always @(posedge CLK)
begin
   FF_ODV_D1 <= FF_ODV;
   FF_ODV_D2 <= FF_ODV_D1;
   FF_ODV_D3 <= FF_ODV_D2;
   FF_ODV_D4 <= FF_ODV_D3;
   FF_ODV_D5 <= FF_ODV_D4;
   AM_CAP    <= DAT_CAP;
end

//`define   Norm_Pkt 3'd0  //Normal data packet
//`define   INTR_Pkt 3'd1  //Interrupt Status/ID packet
//`define   INFO_Pkt 3'd2  //Informational packet
//`define   WARN_Pkt 3'd3  //Warning packet
//`define   ERR_Pkt  3'd4  //Error packet

always @(posedge CLK)
begin
   if(LOAD_DATA_REG)
      if(IH_ERR || IH_WARN)
         begin
            MER_REG <= 16'h0000;
            VSTATE_REG <= 16'h0000;
            DATA_REG <= {32'h00000000,`VME_IH,4'h0,IH_ERR_REG,4'h0,1'b0,IH_A,1'b0,IH_IRQ};
            DATA_SIZE <= {1'b0,`LWord};
            PKT_TYP <= (IH_ERR) ? `ERR_Pkt : `WARN_Pkt;
         end
      else if(IH_DAV)
         begin
            MER_REG <= 16'h0000;
            VSTATE_REG <= 16'h0000;
            DATA_REG <= RSLT_DATA;
            DATA_SIZE <= {1'b0,IH_DT_SZ};
            PKT_TYP <= `INTR_Pkt;
         end
      else if(MSTR_ERR)
         begin
            MER_REG <= {`VME_Master,4'h0,MSTR_ERR_REG};
            VSTATE_REG <= {5'h00,MSTR_AM,MSTR_WRT_RDB,MSTR_DATA_SZ,MSTR_TT};
            DATA_REG <= MSTR_FADDR;
            DATA_SIZE <= {1'b1,MSTR_DATA_SZ};
            PKT_TYP <= `ERR_Pkt;
         end
      else if(MSTR_DAV)
         begin
            MER_REG <= 16'h0000;
            VSTATE_REG <= 16'h0000;
            DATA_REG <= RSLT_DATA;
            DATA_SIZE <= {1'b0,MSTR_DATA_SZ};
            PKT_TYP <= `Norm_Pkt;
         end
      else if(CTRL_ERR)
         begin
            MER_REG <= {`VME_Ctrl,8'h0,CTRL_ERR_REG};
            VSTATE_REG <= {ACCS_TYP,DLY_TYP,ADDR_SZ,WRT_RDB,DATA_SZ,TRNS_TYP};
            DATA_REG <= 64'h0000000000000000;
            DATA_SIZE <= {1'b1,DATA_SZ};
            PKT_TYP <= `ERR_Pkt;
         end
   else
      begin
         MER_REG <= MER_REG;
         VSTATE_REG <= VSTATE_REG;
         DATA_REG <= DATA_REG;
         DATA_SIZE <= DATA_SIZE;
      end
end


always @(posedge CLK)
begin
   if(LOAD_TYPE)
      begin
         DLY_TYP <= DATA_IN[10:8];
         ADDR_SZ <= DATA_IN[7:5];
         WRT_RDB <= DATA_IN[4];
         DATA_SZ <= DATA_IN[3:2];
         TRNS_TYP <= DATA_IN[1:0];
         ACCS_TYP <= DATA_IN[15:11];
         UAM <= DATA_IN[15];
         PRG <= DATA_IN[11];
         if(DATA_IN[10:8] == 3'd0) // Delay type is zero
            case(DATA_IN[7:5])     // Address Size
               `ASZ_A16:           //A16        (1 word to read)
                  FTCH_WRDS <= 3'd1;
               `ASZ_A24,`ASZ_A32:  //A24,A32 (2 words to read)
                  FTCH_WRDS <= 3'd2;
               `ASZ_A40:           //A40        (3 words to read)
                  FTCH_WRDS <= 3'd3;
               `ASZ_A64:           //A64        (4 words to read)
                  FTCH_WRDS <= 3'd4;
               default:            // no addr to read
                  FTCH_WRDS <= 3'd0;
            endcase
         else  // Delay type is not zero
            case(DATA_IN[10:8])            // Delay Type
               `D4nsX16,`D16nsX16,`D16usX16: // (1 delay word to read)
                  FTCH_WRDS <= 3'd1;
               `D4nsX32,`D16nsX32,`D16usX32: // (2 words to read)
                  FTCH_WRDS <= 3'd2;
               default:                         // (nothing to read)
                  FTCH_WRDS <= 3'd0;
            endcase
      end
   else
      begin
         DLY_TYP <= DLY_TYP;
         ADDR_SZ <= ADDR_SZ;
         WRT_RDB <= WRT_RDB;
         DATA_SZ <= DATA_SZ;
         TRNS_TYP <= TRNS_TYP;
         ACCS_TYP <= ACCS_TYP;
         UAM <= UAM;
         PRG <= PRG;
         FTCH_WRDS <= FTCH_WRDS;
      end
end
always @(posedge CLK)
begin
   if(ADDR_PHASE && FFODV1 && UAM) 
      UD_AM <= DATA_IN[5:0];
   else
      UD_AM <= UD_AM;
end

always @(posedge CLK)
begin
   if(ADDR_PHASE && DAT_CAP) 
      casex ({ADDR_SZ,ACCS_TYP})
         `Usr_AM:     //AM = user defined (UD_AM)
            AD_MOD <= UD_AM;
         `CR_CSR_AM:  //AM = 2F
            AD_MOD <= 6'h2F;
         `A16LCK_AM:  //AM = 2C
            if(TRNS_TYP == `BLOCK || DATA_SZ == `Eight)
               AD_MOD <= 6'h02;
            else
               AD_MOD <= 6'h2C;
         `A16SUP_AM:  //AM = 2D
            if(TRNS_TYP == `BLOCK || DATA_SZ == `Eight)
               AD_MOD <= 6'h02;
            else
               AD_MOD <= 6'h2D;
         `A16non_AM:  //AM = 29
            if(TRNS_TYP == `BLOCK || DATA_SZ == `Eight)
               AD_MOD <= 6'h02;
            else
               AD_MOD <= 6'h29;
         `A24LCK_AM:  //AM = 32
            AD_MOD <= 6'h32;
         `A24SUP_AM:  //AM = 3C-3F
            if(TRNS_TYP == `BLOCK)
               if(DATA_SZ == `Eight)
                  AD_MOD <= 6'h3C;
               else
                  AD_MOD <= 6'h3F;
            else
               if(PRG)
                  AD_MOD <= 6'h3E;
               else
                  AD_MOD <= 6'h3D;
         `A24non_AM:  //AM = 38-3B
            if(TRNS_TYP == `BLOCK)
               if(DATA_SZ == `Eight)
                  AD_MOD <= 6'h38;
               else
                  AD_MOD <= 6'h3B;
            else
               if(PRG)
                  AD_MOD <= 6'h3A;
               else
                  AD_MOD <= 6'h39;
         `A32LCK_AM:  //AM = 05
            AD_MOD <= 6'h05;
         `A32SUP_AM:  //AM = 0C-0F
            if(TRNS_TYP == `BLOCK)
               if(DATA_SZ == `Eight)
                  AD_MOD <= 6'h0C;
               else
                  AD_MOD <= 6'h0F;
            else
               if(PRG)
                  AD_MOD <= 6'h0E;
               else
                  AD_MOD <= 6'h0D;
         `A32non_AM:  //AM = 08-0B
            if(TRNS_TYP == `BLOCK)
               if(DATA_SZ == `Eight)
                  AD_MOD <= 6'h08;
               else
                  AD_MOD <= 6'h0B;
            else
               if(PRG)
                  AD_MOD <= 6'h0A;
               else
                  AD_MOD <= 6'h09;
         `A40LCK_AM:  //AM = 35
            if(DATA_SZ == `Eight)
               AD_MOD <= 6'h02;
            else
               AD_MOD <= 6'h35;
         `A40_AM:     //AM = 34,37
            if(DATA_SZ == `Eight)
               AD_MOD <= 6'h02;
            else if(TRNS_TYP == `BLOCK)
               AD_MOD <= 6'h37;
            else
               AD_MOD <= 6'h34;
         `A64LCK_AM:  //AM = 04
            AD_MOD <= 6'h04;
         `A64_AM:     //AM = 00,01,03
            if(TRNS_TYP == `BLOCK)
               if(DATA_SZ == `Eight)
                  AD_MOD <= 6'h00;
               else
                  AD_MOD <= 6'h03;
            else
               AD_MOD <= 6'h01;
         default:
            AD_MOD <= 6'h02;
      endcase
   else
      AD_MOD <= AD_MOD;
end

always @(posedge CLK)
begin
   if(ADDR_PHASE)
      if(DLY_TYP == `No_Dly)
         case(ADDR_SZ)
            `ASZ_A16: //A16
               if(FFODV1&&!UAM || FFODV2&&UAM) 
                  FULL_ADDR <= {48'h000000000000,DATA_IN};
               else
                  FULL_ADDR <= FULL_ADDR;
            `ASZ_A24:        //A24
               if(FFODV1&&!UAM || FFODV2&&UAM)
                  FULL_ADDR <= {40'h0000000000,DATA_IN[7:0],FULL_ADDR[15:0]};
               else if(FFODV2&&!UAM || FFODV3&&UAM)
                  FULL_ADDR <= {40'h0000000000,FULL_ADDR[23:16],DATA_IN};
               else
                  FULL_ADDR <= FULL_ADDR;
            `ASZ_A32: //A32
               if(FFODV1&&!UAM || FFODV2&&UAM)
                  FULL_ADDR <= {32'h00000000,DATA_IN,FULL_ADDR[15:0]};
               else if(FFODV2&&!UAM || FFODV3&&UAM)
                  FULL_ADDR <= {32'h00000000,FULL_ADDR[31:16],DATA_IN};
               else
                  FULL_ADDR <= FULL_ADDR;
            `ASZ_A40:        //A40
               if(FFODV1&&!UAM || FFODV2&&UAM)
                  FULL_ADDR <= {24'h000000,DATA_IN[7:0],FULL_ADDR[31:0]};
               else if(FFODV2&&!UAM || FFODV3&&UAM)
                  FULL_ADDR <= {24'h000000,FULL_ADDR[39:32],DATA_IN[15:0],FULL_ADDR[15:0]};
               else if(FFODV3&&!UAM || FFODV4&&UAM)
                  FULL_ADDR <= {24'h000000,FULL_ADDR[39:16],DATA_IN};
               else
                  FULL_ADDR <= FULL_ADDR;
            `ASZ_A64:        //A64
               if(FFODV1&&!UAM || FFODV2&&UAM)
                  FULL_ADDR <= {DATA_IN,FULL_ADDR[47:0]};
               else if(FFODV2&&!UAM || FFODV3&&UAM)
                  FULL_ADDR <= {FULL_ADDR[63:48],DATA_IN,FULL_ADDR[31:0]};
               else if(FFODV3&&!UAM || FFODV4&&UAM)
                  FULL_ADDR <= {FULL_ADDR[63:32],DATA_IN,FULL_ADDR[15:0]};
               else if(FFODV4&&!UAM || FFODV5&&UAM)
                  FULL_ADDR <= {FULL_ADDR[63:16],DATA_IN};
               else
                  FULL_ADDR <= FULL_ADDR;
            default:                  // no addr to read
               FULL_ADDR <= FULL_ADDR;
         endcase
      else
         case(DLY_TYP)
            `D4nsX16,`D16nsX16,`D16usX16: //16 Bit range
               if(FFODV1)
                  FULL_ADDR <= {48'h000000000000,DATA_IN};
               else
                  FULL_ADDR <= FULL_ADDR;
            `D4nsX32,`D16nsX32,`D16usX32:        //32 Bit range
               if(FFODV1)
                  FULL_ADDR <= {32'h00000000,DATA_IN,FULL_ADDR[15:0]};
               else if(FFODV2)
                  FULL_ADDR <= {32'h00000000,FULL_ADDR[31:16],DATA_IN};
               else
                  FULL_ADDR <= FULL_ADDR;
            default:                  // no addr to read
               FULL_ADDR <= FULL_ADDR;
         endcase
   else
      FULL_ADDR <= FULL_ADDR;
end
always @(posedge CLK)
begin
   if(DATA_PHASE)
      case(DATA_SZ)
         `Byte:
            if(FFODV1)
               FULL_DATA <= {56'h00000000000000,DATA_IN[7:0]};
            else
               FULL_DATA <= FULL_DATA;
         `Word:
            if(FFODV1)
               FULL_DATA <= {48'h000000000000,DATA_IN};
            else
               FULL_DATA <= FULL_DATA;
         `LWord:
            if(FFODV1)
               FULL_DATA <= {32'h00000000,DATA_IN,FULL_DATA[15:0]};
            else if(FFODV2)
               FULL_DATA <= {32'h00000000,FULL_DATA[31:16],DATA_IN};
            else
               FULL_DATA <= FULL_DATA;
         `Eight:
            if(FFODV1)
               FULL_DATA <= {DATA_IN,FULL_DATA[47:0]};
            else if(FFODV2)
               FULL_DATA <= {FULL_DATA[63:48],DATA_IN,FULL_DATA[31:0]};
            else if(FFODV3)
               FULL_DATA <= {FULL_DATA[63:32],DATA_IN,FULL_DATA[15:0]};
            else if(FFODV4)
               FULL_DATA <= {FULL_DATA[63:16],DATA_IN};
            else
               FULL_DATA <= FULL_DATA;
         default:
               FULL_DATA <= FULL_DATA;
      endcase
   else
      FULL_DATA <= FULL_DATA;
end
    
always @(posedge CLK or posedge RST)
begin: VME_WRT_CTRL_FSM
   if(RST)
      VWRT_ST <= `VW_idle;
   else
      case(VWRT_ST)
         `VW_idle:
            begin
               if((IN_CTRL_CODE == `VME_CMD_FF) && FF_HAS_DATA)
                  VWRT_ST <= `VW_Req_Bus;
               else 
                  VWRT_ST <= `VW_idle;
            end
         `VW_Req_Bus:
            begin
               if(BG_VMEW)
                  VWRT_ST <= `Rd_FIFO;
               else 
                  VWRT_ST <= `VW_Req_Bus;
            end
         `Rd_FIFO:
            begin
               if(!FF_RHOLD)
                  VWRT_ST <= `Rd_units;
               else 
                  VWRT_ST <= `Rd_FIFO;
            end
         `Rd_units:
            VWRT_ST <= `Ld_units;
         `Ld_units:
            begin
               if(FF_RD_ERR)
                  VWRT_ST <= `Rd_Err_Units;
               else if(FF_ODV)
                  VWRT_ST <= `Rd_type;
               else 
                  VWRT_ST <= `Ld_units;
            end
         `Rd_type:
            VWRT_ST <= `Ld_type;
         `Ld_type:
            begin
               if(FF_RD_ERR)
                  VWRT_ST <= `Rd_Err_CtrlWrd;
               else if(DAT_CAP)
                  if(BAD_DLY)
                     VWRT_ST <= `Unkn_Dly_Typ;
                  else if(UAM && (DLY_TYP == `No_Dly))
                     VWRT_ST <= `Rd_UAM;
                  else
                     case(FTCH_WRDS)
                        3'd1:          //(1 word to read)
                           VWRT_ST <= `Rd_Wrd_1a;
                        3'd2:          //(2 words to read)
                           VWRT_ST <= `Rd_Wrd_1b;
                        3'd3:          //(3 words to read)
                           VWRT_ST <= `Rd_Wrd_1c;
                        3'd4:          //(4 words to read)
                           VWRT_ST <= `Rd_Wrd_1d;
                        default:       // no addr to read
                           VWRT_ST <= `Unkn_Addr_Sz;
                     endcase
               else 
                  VWRT_ST <= `Ld_type;
            end
         `Rd_UAM:
            case(FTCH_WRDS)
               3'd1:          //(1 word to read)
                  VWRT_ST <= `Rd_Wrd_1a;
               3'd2:          //(2 words to read)
                  VWRT_ST <= `Rd_Wrd_1b;
               3'd3:          //(3 words to read)
                  VWRT_ST <= `Rd_Wrd_1c;
               3'd4:          //(4 words to read)
                  VWRT_ST <= `Rd_Wrd_1d;
               default:       // no addr to read
                  VWRT_ST <= `Unkn_Addr_Sz;
            endcase
         `Rd_Wrd_1a:
            VWRT_ST <= `Ld_Add_Pause;
         `Rd_Wrd_1b:
            VWRT_ST <= `Rd_Wrd_2b;
         `Rd_Wrd_2b:
            VWRT_ST <= `Ld_Add_Pause;
         `Rd_Wrd_1c:
            VWRT_ST <= `Rd_Wrd_2c;
         `Rd_Wrd_2c:
            VWRT_ST <= `Rd_Wrd_3c;
         `Rd_Wrd_3c:
            VWRT_ST <= `Ld_Add_Pause;
         `Rd_Wrd_1d:
            VWRT_ST <= `Rd_Wrd_2d;
         `Rd_Wrd_2d:
            VWRT_ST <= `Rd_Wrd_3d;
         `Rd_Wrd_3d:
            if(FF_RD_ERR)
               VWRT_ST <= `Rd_Err_Addr;
            else
               VWRT_ST <= `Rd_Wrd_4d;
         `Rd_Wrd_4d:
            if(FF_RD_ERR)
               VWRT_ST <= `Rd_Err_Addr;
            else
               VWRT_ST <= `Ld_Add_Pause;
         `Ld_Add_Pause:
            begin
               if(FF_RD_ERR)
                  VWRT_ST <= `Rd_Err_Addr;
               else if(AM_CAP)
                  if((AD_MOD == 6'h02) && (DLY_TYP == `No_Dly))
                     VWRT_ST <= `Incomp_Opt;
                  else if((TRNS_TYP == `BLOCK) && (DLY_TYP == `No_Dly))
                     VWRT_ST <= `Rd_Dcnt;
                  else
                     VWRT_ST <= `Continue;
               else 
                  VWRT_ST <= `Ld_Add_Pause;
            end
         `Rd_Dcnt:
            VWRT_ST <= `Ld_Dcnt;
         `Ld_Dcnt:
            begin
               if(FF_RD_ERR)
                  VWRT_ST <= `Rd_Err_Dcnt;
               else if(FF_ODV)
                  VWRT_ST <= `Continue;
               else 
                  VWRT_ST <= `Ld_Dcnt;
            end
         `Continue:
            begin
               if(WRT_RDB && (DLY_TYP == `No_Dly))
                  case(DATA_SZ)
                     `LWord:          //D32 Quad byte (2 words to read)
                        VWRT_ST <= `Rd_Dat_1b;
                     `Eight:          //D64        Eight bytes (4 words to read)
                        VWRT_ST <= `Rd_Dat_1d;
                     default:         // D08, & D16; Byte, & Word (1 word to read)
                        VWRT_ST <= `Rd_Dat_1a;
                  endcase
               else 
                  VWRT_ST <= `VPause;
            end
         `Rd_Dat_1a:
            if(MSTR_ERR && BIP)
               if(LAST_WORD)
                  VWRT_ST <= `Clr_Mstr_Err1;
               else
                  VWRT_ST <= `Dec_Dcnt;
            else
               VWRT_ST <= `Ld_Dat_Pause;
         `Rd_Dat_1b:
            VWRT_ST <= `Rd_Dat_2b;
         `Rd_Dat_2b:
            if(MSTR_ERR && BIP)
               if(LAST_WORD)
                  VWRT_ST <= `Clr_Mstr_Err1;
               else
                  VWRT_ST <= `Dec_Dcnt;
            else
               VWRT_ST <= `Ld_Dat_Pause;
         `Rd_Dat_1d:
            VWRT_ST <= `Rd_Dat_2d;
         `Rd_Dat_2d:
            VWRT_ST <= `Rd_Dat_3d;
         `Rd_Dat_3d:
            if(FF_RD_ERR)
               VWRT_ST <= `Rd_Err_Data;
            else
               VWRT_ST <= `Rd_Dat_4d;
         `Rd_Dat_4d:
            if(FF_RD_ERR)
               VWRT_ST <= `Rd_Err_Data;
            else if(MSTR_ERR && BIP)
               if(LAST_WORD)
                  VWRT_ST <= `Clr_Mstr_Err1;
               else
                  VWRT_ST <= `Dec_Dcnt;
            else
               VWRT_ST <= `Ld_Dat_Pause;
         `Ld_Dat_Pause:
            begin
               if(FF_RD_ERR)
                  VWRT_ST <= `Rd_Err_Data;
               else if(DAT_CAP)
                  VWRT_ST <= `VPause;
               else 
                  VWRT_ST <= `Ld_Dat_Pause;
            end
         `VPause:
            begin
               if(MSTR_ERR)
                  if(BIP && LAST_WORD)
                     VWRT_ST <= `Clr_Mstr_Err1;
                  else if(BIP && !LAST_WORD)
                     VWRT_ST <= `Dec_Dcnt;
                  else 
                     VWRT_ST <= `Clr_Mstr_Err2;
               else
                  if((TRNS_TYP == `BLOCK) && (DLY_TYP == `No_Dly) && ((!MSTR_BUSY && !BIP) || (BIP && NEXT_WRD)))
                     VWRT_ST <= `Execute_Blk;
                  else if(!MSTR_BUSY && ((TRNS_TYP != `BLOCK) || (DLY_TYP != `No_Dly)))
                     VWRT_ST <= `Execute;
                  else 
                     VWRT_ST <= `VPause;
            end
         `Execute_Blk:
            begin
               if(MSTR_BUSY && !NEXT_WRD && !LAST_WORD)
                  VWRT_ST <= `Dec_Dcnt;
               else if(MSTR_BUSY && !NEXT_WRD && LAST_WORD)
                  VWRT_ST <= `Dec_Units;
               else 
                  VWRT_ST <= `Execute_Blk;
            end
         `Dec_Dcnt:
            VWRT_ST <= `Continue;
         `Execute:
            begin
               if(MSTR_BUSY)
                  VWRT_ST <= `Dec_Units;
               else 
                  VWRT_ST <= `Execute;
            end
         `Dec_Units:
            begin
               if(LAST_UNIT)
                  VWRT_ST <= `Wait4VRd_Idle;
               else 
                  VWRT_ST <= `Rd_type;
            end
         `Wait4VRd_Idle:
            begin
               if(!MSTR_BUSY && VRD_IDLE)
                  if(ANY_DATA)
                     VWRT_ST <= `Send_Data;
                  else
                     VWRT_ST <= `VW_idle;
               else 
                  VWRT_ST <= `Wait4VRd_Idle;
            end
         `Send_Data:
            begin
               if(SENT)
                  VWRT_ST <= `VW_idle;
               else 
                  VWRT_ST <= `Send_Data;
            end
         `Unkn_Addr_Sz:
            VWRT_ST <= `Rpt_Vctrl_Err;
         `Unkn_Dly_Typ:
            VWRT_ST <= `Rpt_Vctrl_Err;
         `Incomp_Opt:
            VWRT_ST <= `Rpt_Vctrl_Err;
         `Rpt_Vctrl_Err:
            if(ACKN == `V_Ctrl_Err)
               VWRT_ST <= `Flush2BOD;
            else
               VWRT_ST <= `Rpt_Vctrl_Err;
         `Flush2BOD:
            if(FLSHD)
               VWRT_ST <= `Wait4VRd_Idle;
            else
               VWRT_ST <= `Flush2BOD;
         `Clr_Mstr_Err1:
            if(!MSTR_BUSY)
               VWRT_ST <= `Dec_Units;
            else
               VWRT_ST <= `Clr_Mstr_Err1;
         `Clr_Mstr_Err2:
            if(!MSTR_BUSY)
               if((TRNS_TYP == `BLOCK) && (DLY_TYP == `No_Dly))
                  VWRT_ST <= `Execute_Blk;
               else
                  VWRT_ST <= `Execute;
            else
               VWRT_ST <= `Clr_Mstr_Err2;
         `Rd_Err_Units:
            VWRT_ST <= `Rpt_Vctrl_Err;
         `Rd_Err_CtrlWrd:
            VWRT_ST <= `Rpt_Vctrl_Err;
         `Rd_Err_Addr:
            VWRT_ST <= `Rpt_Vctrl_Err;
         `Rd_Err_Dcnt:
            VWRT_ST <= `Rpt_Vctrl_Err;
         `Rd_Err_Data:
            VWRT_ST <= `Rpt_Vctrl_Err;
         default:
            VWRT_ST <= `VW_idle;
      endcase
end


always @(VWRT_ST)
begin
   case (VWRT_ST)
      `VW_idle:
         begin
            RFUNCT <= `RNoOp;
            VMEW_BR <= `VMEW_NoOp;
            CLR_ANY_DATA <= 1;
         end
      `VW_Req_Bus:
         begin
            RFUNCT <= `RNoOp;
            VMEW_BR <= `VME_fr_FIFO;
            CLR_ANY_DATA <= 0;
         end
      `Flush2BOD:
         begin
            RFUNCT <= `Flush_FF;
            VMEW_BR <= `VME_fr_FIFO;
            CLR_ANY_DATA <= 0;
         end
      `Wait4VRd_Idle,`Send_Data:
         begin
            RFUNCT <= `RNoOp;
            VMEW_BR <= `VMEW_NoOp;
            CLR_ANY_DATA <= 0;
         end
      default:
         begin
            RFUNCT <= `Rd_FF;
            VMEW_BR <= `VME_fr_FIFO;
            CLR_ANY_DATA <= 0;
         end
   endcase
end

always @(VWRT_ST or MSTR_ERR)
begin
   case (VWRT_ST)
      `Rpt_Vctrl_Err,`Wait4VRd_Idle:
         CLR_MSTR_ERR <= MSTR_ERR;
      `Clr_Mstr_Err1,`Clr_Mstr_Err2:
         CLR_MSTR_ERR <= 1;
      default:
         CLR_MSTR_ERR <= 0;
   endcase
end

always @(VMEW_BR or RB_BG_VMEW or FB_BG_VMEW or TB_BG_VMEW)
begin
   case(VMEW_BR)
      `VMEW_NoOp:
         BG_VMEW <= 0;
      `VME_fr_FIFO:
         BG_VMEW <= FB_BG_VMEW;
      `VME_cnfg_save:
         BG_VMEW <= RB_BG_VMEW && FB_BG_VMEW && TB_BG_VMEW;
      default:
         BG_VMEW <= 0;
   endcase
end

always @(VWRT_ST)
begin
   case (VWRT_ST)
      `Rd_units,`Rd_type,`Rd_Dcnt:
         begin
            FF_READ <= 1;
            ADDR_PHASE <= 0;
            DATA_PHASE <= 0;
         end
      `Rd_UAM,`Rd_Wrd_1a,`Rd_Wrd_1b,`Rd_Wrd_2b,`Rd_Wrd_1c,`Rd_Wrd_2c,`Rd_Wrd_3c,`Rd_Wrd_1d,`Rd_Wrd_2d,`Rd_Wrd_3d,`Rd_Wrd_4d:
         begin
            FF_READ <= 1;
            ADDR_PHASE <= 1;
            DATA_PHASE <= 0;
         end
      `Ld_Add_Pause:
         begin
            FF_READ <= 0;
            ADDR_PHASE <= 1;
            DATA_PHASE <= 0;
         end
      `Rd_Dat_1a,`Rd_Dat_1b,`Rd_Dat_2b,`Rd_Dat_1d,`Rd_Dat_2d,`Rd_Dat_3d,`Rd_Dat_4d:
         begin
            FF_READ <= 1;
            ADDR_PHASE <= 0;
            DATA_PHASE <= 1;
         end
      `Ld_Dat_Pause:
         begin
            FF_READ <= 0;
            ADDR_PHASE <= 0;
            DATA_PHASE <= 1;
         end
      default:  
         begin
            FF_READ <= 0;
            ADDR_PHASE <= 0;
            DATA_PHASE <= 0;
         end
   endcase
end

always @(VWRT_ST or FF_ODV)
begin
   case (VWRT_ST)
      `Ld_units:
         begin
            LOAD_UNITS <= FF_ODV;
            LOAD_TYPE <= 0;
            LOAD_DCNT <= 0;
         end
      `Ld_type:
         begin
            LOAD_UNITS <= 0;
            LOAD_TYPE <= FF_ODV;
            LOAD_DCNT <= 0;
         end
      `Ld_Dcnt:
         begin
            LOAD_UNITS <= 0;
            LOAD_TYPE <= 0;
            LOAD_DCNT <= FF_ODV;
         end
      default:
         begin
            LOAD_UNITS <= 0;
            LOAD_TYPE <= 0;
            LOAD_DCNT <= 0;
         end
   endcase
end


always @(VWRT_ST)
begin
   case (VWRT_ST)
      `Rpt_Vctrl_Err:
         CTRL_ERR <= 1;
      default:
         CTRL_ERR <= 0;
   endcase
end

always @(VWRT_ST)
begin
   case (VWRT_ST)
      `Send_Data:
         SEND <= 1;
      default:
         SEND <= 0;
   endcase
end

always @(VWRT_ST )
begin
   case (VWRT_ST)
      `Execute:
         begin
            DEC_UNITS <= 0;
            DEC_DCNT <= 0;
            EXECUTE <= 1;
            SET_BIP <= 0;
            RST_BIP <= 0;
            NEXT_RDY <= 0;
         end
      `Execute_Blk:
         begin
            DEC_UNITS <= 0;
            DEC_DCNT <= 0;
            EXECUTE <= 1;
            SET_BIP <= 1;
            RST_BIP <= 0;
            NEXT_RDY <= 1;
         end
      `Dec_Units:
         begin
            DEC_UNITS <= 1;
            DEC_DCNT <= 0;
            EXECUTE <= 0;
            SET_BIP <= 0;
            RST_BIP <= 1;
            NEXT_RDY <= 0;
         end
      `Dec_Dcnt:
         begin
            DEC_UNITS <= 0;
            DEC_DCNT <= 1;
            EXECUTE <= 0;
            SET_BIP <= 0;
            RST_BIP <= 0;
            NEXT_RDY <= 0;
         end
      default:
         begin
            DEC_UNITS <= 0;
            DEC_DCNT <= 0;
            EXECUTE <= 0;
            SET_BIP <= 0;
            RST_BIP <= 0;
            NEXT_RDY <= 0;
         end
   endcase
end

always @(posedge CLK)
begin
   if(RST)
      UNITS <= 0;
   else
      if (LOAD_UNITS)
         UNITS <= DATA_IN;
      else if (DEC_UNITS)
         UNITS <= UNITS -1;
      else
         UNITS <= UNITS;
end
always @(posedge CLK)
begin
   if(RST)
      DCNT <= 16'h0001;
   else
      if (LOAD_DCNT)
         DCNT <= DATA_IN;
      else if (DEC_DCNT)
         DCNT <= DCNT -1;
      else
         DCNT <= DCNT;
end
always @(posedge CLK)
begin
   if (RST || RST_BIP)
      BIP <= 0;
   else if(SET_BIP)
      BIP <= 1;
   else
      BIP <= BIP;
end

always @(posedge CLK)
begin         // VME Controller Error Register
   if (ACKN == `V_Ctrl_Err)
      CTRL_ERR_REG <= `No_Cerr;
   else
      case (VWRT_ST)
         `Unkn_Addr_Sz:
            CTRL_ERR_REG <= `Unkn_Addr; 
         `Unkn_Dly_Typ:
            CTRL_ERR_REG <= `Unkn_Dly; 
         `Incomp_Opt:
            CTRL_ERR_REG <= `Inc_Opt; 
         `Rd_Err_Units:
            CTRL_ERR_REG <= `RdEr_Units; 
         `Rd_Err_CtrlWrd:
            CTRL_ERR_REG <= `RdEr_CtrlWrd; 
         `Rd_Err_Addr:
            CTRL_ERR_REG <= `RdEr_Addr; 
         `Rd_Err_Dcnt:
            CTRL_ERR_REG <= `RdEr_Dcnt; 
         `Rd_Err_Data:
            CTRL_ERR_REG <= `RdEr_Data; 
         default:
            CTRL_ERR_REG <= CTRL_ERR_REG;
      endcase
end

///////////////////////////////////////////////////////////////
//                                                           //
// VME Read control                                          //
//                                                           //
///////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////
//                                                           //
// Read FIFO write control                                   //
//                                                           //
///////////////////////////////////////////////////////////////

always @(posedge CLK or posedge RST)
begin
   if(RST)
      begin
         RSPD <= `No_Req;
         ACKN_MSK <= 6'b000000;
      end
   else
      if(SET_VLDT)
         casex ({IH_ERR, MSTR_ERR, CTRL_ERR, IH_DAV, MSTR_DAV, IH_WARN})
            6'b1xxxxx:
               begin
                  RSPD <= `V_IH_Err;
                  ACKN_MSK <= 6'b100000;
               end
            6'b01xxxx:
               begin
                  RSPD <= `V_Mstr_Err;
                  ACKN_MSK <= 6'b010000;
               end
            6'b001xxx:
               begin
                  RSPD <= `V_Ctrl_Err;
                  ACKN_MSK <= 6'b001000;
               end
            6'b0001xx:
               begin
                  RSPD <= `V_IH_Dav;
                  ACKN_MSK <= 6'b000100;
               end
            6'b00001x:
               begin
                  RSPD <= `V_Mstr_Dav;
                  ACKN_MSK <= 6'b000010;
               end
            6'b000001:
               begin
                  RSPD <= `V_IH_Warn;
                  ACKN_MSK <= 6'b000001;
               end
            default:
               begin
                  RSPD <= `No_Req;
                  ACKN_MSK <= 6'b000000;
               end
         endcase
      else if(VRD_IDLE)
         begin
            RSPD <= `No_Req;
            ACKN_MSK <= 6'b000000;
         end
      else
         begin
            RSPD <= RSPD;
            ACKN_MSK <= ACKN_MSK;
         end
end

always @(posedge CLK or posedge RST)
begin
   if(RST)
      ACKN <= `No_Req;
   else
      if(LD_ACKN)
         ACKN <= RSPD;
      else if(RST_ACKN)
         ACKN <= `No_Req;
      else
         ACKN <= ACKN;
end

always @(posedge CLK or posedge RST)
begin: VME_RD_FFWRT_CTRL_FSM
   if(RST)
      VFFW_ST <= `VRd_Idle;
   else
      case(VFFW_ST)
         `VRd_Idle:
            begin
               if(ANY_DAV)
                  VFFW_ST <= `Ld_Drbk;
               else if(SEND)
                  VFFW_ST <= `Push_EOP;
               else 
                  VFFW_ST <= `VRd_Idle;
            end
         `Ld_Drbk:
            begin
               if(MSTR_WRT_RDB==0 && MSTR_ERR)
                  case (MSTR_DATA_SZ)
                     `Byte:
                        VFFW_ST <= `Dummy8;
                     `Word:
                        VFFW_ST <= `Dummy16;
                     `LWord:
                        VFFW_ST <= `Dummy32A;
                     `Eight:
                        VFFW_ST <= `Dummy64A;
                     default:
                        VFFW_ST <= `Dummy16;
                  endcase
               else
                  VFFW_ST <= `Ackn;
            end
         `Dummy8:
            VFFW_ST <= `Ackn;
         `Dummy16:
            VFFW_ST <= `Ackn;
         `Dummy32A:
            VFFW_ST <= `Dummy32B;
         `Dummy32B:
            VFFW_ST <= `Ackn;
         `Dummy64A:
            VFFW_ST <= `Dummy64B;
         `Dummy64B:
            VFFW_ST <= `Dummy64C;
         `Dummy64C:
            VFFW_ST <= `Dummy64D;
         `Dummy64D:
            VFFW_ST <= `Ackn;
         `Ackn:
            begin
               casex (DATA_SIZE)
                 {1'b0,`Byte}:
                     VFFW_ST <= `Push8;
                 {1'b0,`Word}:
                     VFFW_ST <= `Push16;
                 {1'b0,`LWord}:
                     VFFW_ST <= `Push32A;
                 {1'b0,`Eight}:
                     VFFW_ST <= `Push64A;
                 3'b1xx:
                     VFFW_ST <= `Push_MER;
                 default:
                     VFFW_ST <= `Push16;
               endcase
            end
         `Push8:
            VFFW_ST <= `Rd_Cmplt;
         `Push16:
            VFFW_ST <= `Rd_Cmplt;
         `Push32A:
            VFFW_ST <= `Push32B;
         `Push32B:
            VFFW_ST <= `Rd_Cmplt;
         `Push64A:
            VFFW_ST <= `Push64B;
         `Push64B:
            VFFW_ST <= `Push64C;
         `Push64C:
            VFFW_ST <= `Push64D;
         `Push64D:
            VFFW_ST <= `Rd_Cmplt;
         `Push_MER:
            VFFW_ST <= `Push_VState;
         `Push_VState:
            if(RSPD == `V_Mstr_Err)
               VFFW_ST <= `Push64A;
            else
               VFFW_ST <= `Rd_Cmplt;
         `Rd_Cmplt:
            if(ACKN == `No_Req)
               VFFW_ST <= `VRd_Idle;
            else
               VFFW_ST <= `Rd_Cmplt;
         `Push_EOP:
            VFFW_ST <= `Data_Pkt_Sent;
         `Data_Pkt_Sent:
            if(!SEND)
               VFFW_ST <= `VRd_Idle;
            else
               VFFW_ST <= `Data_Pkt_Sent;
         default:
            VFFW_ST <= `VRd_Idle;
      endcase
end

always @(VFFW_ST or ANY_DAV or ANY_MSG or IH_DAV)
begin
   case (VFFW_ST)
      `VRd_Idle:
         begin
            SET_EOP <= ANY_MSG || IH_DAV;
            SET_VLDT <= ANY_DAV;
            RD_CMPLT <= 0;
            VRD_IDLE <= 1;
         end
      `Rd_Cmplt:
         begin
            SET_EOP <= 0;
            SET_VLDT <= 0;
            RD_CMPLT <= 1;
            VRD_IDLE <= 0;
         end
      default:
         begin
            SET_EOP <= 0;
            SET_VLDT <= 0;
            RD_CMPLT <= 0;
            VRD_IDLE <= 0;
         end
   endcase
end
always @(posedge CLK)
begin
   if (RST || RD_CMPLT)
      EOP <= 0;
   else if(SET_EOP)
      EOP <= 1;
   else
      EOP <= EOP;
   if (RST || RD_CMPLT)
      VLDT <= 0;
   else if(SET_VLDT)
      VLDT <= 1;
   else
      VLDT <= VLDT;
   if (CLR_ANY_DATA)
      ANY_DATA <= 0;
   else if(PUSH && (PKT_TYP_WR == `Norm_Pkt))
      ANY_DATA <= 1;
   else
      ANY_DATA <= ANY_DATA;
end

always @(VFFW_ST)
begin
   case (VFFW_ST)
      `Dummy8,`Dummy16,`Dummy32A,`Dummy32B,`Dummy64A,`Dummy64B,`Dummy64C,`Dummy64D,
      `Push_MER,`Push_VState,`Push_EOP,
      `Push8,`Push16,`Push32A,`Push32B,`Push64A,`Push64B,`Push64C,`Push64D:
         PUSH <= 1;
      default:
         PUSH <= 0;
   endcase
end
always @(VFFW_ST or EOP or RSPD)
begin
   case (VFFW_ST)
      `Push8,`Push16,`Push32B,`Push64D:
         EOP_WR <= EOP;
      `Push_VState:
         EOP_WR <= EOP && (RSPD == `V_Ctrl_Err);
      `Push_EOP:
         EOP_WR <= 1;
      default:
         EOP_WR <= 0;
   endcase
end
always @(VFFW_ST)
begin
   case (VFFW_ST)
      `Ld_Drbk:
         LOAD_DATA_REG <= 1;
      default:
         LOAD_DATA_REG <= 0;
   endcase
end
always @(VFFW_ST)
begin
   case (VFFW_ST)
      `Ackn:
         LD_ACKN <= 1;
      default:
         LD_ACKN <= 0;
   endcase
end
always @(VFFW_ST)
begin
   case (VFFW_ST)
      `Data_Pkt_Sent:
         SENT <= 1;
      default:
         SENT <= 0;
   endcase
end

always @(VFFW_ST or PKT_TYP)
begin
   case (VFFW_ST)
      `Push_EOP,`Dummy8,`Dummy16,`Dummy32A,`Dummy32B,`Dummy64A,`Dummy64B,`Dummy64C,`Dummy64D:
         PKT_TYP_WR <= `Norm_Pkt;
      `Push_MER,`Push_VState,
      `Push8,`Push16,`Push32A,`Push32B,`Push64A,`Push64B,`Push64C,`Push64D:
         PKT_TYP_WR <= PKT_TYP;
      default:
         PKT_TYP_WR <= PKT_TYP;
   endcase
end

always @(VFFW_ST or DATA_REG or MER_REG or VSTATE_REG)
begin
   case (VFFW_ST)
      `Dummy8:
         VFF_IN <= 16'h00BD;
      `Dummy16:
         VFF_IN <= 16'hBAAD;
      `Dummy32A:
         VFF_IN <= 16'hBAAD;
      `Dummy32B:
         VFF_IN <= 16'hBEEF;
      `Dummy64A:
         VFF_IN <= 16'hBADC;
      `Dummy64B:
         VFF_IN <= 16'h0DEC;
      `Dummy64C:
         VFF_IN <= 16'h0FFE;
      `Dummy64D:
         VFF_IN <= 16'hEBAD;
      `Push8:
         VFF_IN <= {8'h00,DATA_REG[7:0]};
      `Push16,`Push32B,`Push64D:
         VFF_IN <= DATA_REG[15:0];
      `Push32A,`Push64C:
         VFF_IN <= DATA_REG[31:16];
      `Push64B:
         VFF_IN <= DATA_REG[47:32];
      `Push64A:
         VFF_IN <= DATA_REG[63:48];
      `Push_MER:
         VFF_IN <= MER_REG;
      `Push_VState:
         VFF_IN <= VSTATE_REG;
      default:
         VFF_IN <= DATA_REG[15:0];
   endcase
end


///////////////////////////////////////////////////////////////
//                                                           //
// FIFO for Readback data from VME                           //
//                                                           //
///////////////////////////////////////////////////////////////
 
//defparam VME_dwrt_ptr.width = 10;
//defparam VME_drd_ptr.width = 10;
//defparam VME_FF_cntr.width = 10;
defparam VME_dwrt_ptr.width = 4;
defparam VME_drd_ptr.width = 4;
defparam VME_FF_cntr.width = 4;

cnt_up VME_dwrt_ptr (.clk(CLK),.inc(PUSH),.r(RST),.count(VME_WADDR));
// 1k X 16 Dual Port RAM for VME readback data
//dpm_1kX18 VME_fifo(.clk(CLK),.we(PUSH),.a(VME_WADDR),.dpra(VME_RADDR),.di({EOP_WR,VLDT,VFF_IN}),.dpo({EOP_RD,VLDT_RD,VFF_OUT})); 
//dpm_16X18 VME_fifo(.clk(CLK),.we(PUSH),.a(VME_WADDR),.dpra(VME_RADDR),.di({EOP_WR,VLDT,VFF_IN}),.dpo({EOP_RD,VLDT_RD,VFF_OUT})); 
//
// Adding three bits for data type 
//`define   Norm_Pkt 3'd0  //Normal data packet
//`define   INTR_Pkt 3'd1  //Interrupt Status/ID packet
//`define   INFO_Pkt 3'd2  //Informational packet
//`define   WARN_Pkt 3'd3  //Warning packet
//`define   ERR_Pkt  3'd4  //Error packet
//
dpm_24X21 VME_fifo(.clk(CLK),.we(PUSH),.a(VME_WADDR),.dpra(VME_RADDR),.di({PKT_TYP_WR,EOP_WR,VLDT,VFF_IN}),.dpo({PKT_TYP_RD,EOP_RD,VLDT_RD,VFF_OUT})); 
cnt_up  VME_drd_ptr (.clk(CLK),.inc(V_POP),.r(RST),.count(VME_RADDR));

cnt_up_dwn VME_FF_cntr (.clk(CLK),.ce(VFF_CE),.dir(VFF_DIR),.r(RST),.count(VFF_CNT));

always @ (PUSH or POP or VFF_MT)
begin
  casex ({VFF_MT,PUSH,POP})
     3'b001:
       begin                  // count down
         VFF_CE <= 1'b1;
         VFF_DIR <= 1'b0;
         V_POP <= 1'b1;         // Increment address
       end
     3'bx10,3'b111:
       begin
         VFF_CE <= 1'b1;          // count up
         VFF_DIR <= 1'b1;
         V_POP <= 1'b0;         // Don't increment address
       end
     3'b011:
       begin                  // hold
         VFF_CE <= 1'b0;
         VFF_DIR <= 1'b1;
         V_POP <= 1'b1;         // Increment address
       end
     default:                  // hold
       begin
         VFF_CE <= 1'b0;
         VFF_DIR <= 1'b1;
         V_POP <= 1'b0;
       end
  endcase
end

///////////////////////////////////////////////////////////////
//                                                           //
// Read FIFO read control                                    //
//                                                           //
///////////////////////////////////////////////////////////////

always @(posedge CLK or posedge RST)
begin: VME_RD_FFRD_CTRL_FSM
   if(RST)
      VFFR_ST <= `VR_idle;
   else
      case(VFFR_ST)
         `VR_idle:
            begin
               if(!VFF_MT)
                  VFFR_ST <= `Get_Bus;
               else 
                  VFFR_ST <= `VR_idle;
            end
         `Get_Bus:
            begin
               if(TB_BG_VMER)
                  VFFR_ST <= `Pop_VFF;
               else 
                  VFFR_ST <= `Get_Bus;
            end
         `Pop_VFF:
            begin
               if(VD1 && EOP_RD && !VLDT_RD)
                  VFFR_ST <= `Send_Gap;
               else if(VD1 && EOP_RD && VLDT_RD)
                  VFFR_ST <= `Last_Word;
               else if(!VFF_MT)
                  VFFR_ST <= `Pop_VFF;
               else 
                  VFFR_ST <= `Wait4NMT;
            end
         `Wait4NMT:
            begin
               if(!VFF_MT)
                  VFFR_ST <= `Pop_VFF;
               else 
                  VFFR_ST <= `Wait4NMT;
            end
         `Last_Word:
            VFFR_ST <= `Send_Gap;
         `Send_Gap:
            VFFR_ST <= `GbE_Send;
         `GbE_Send:
            begin
               if(!VFF_MT)
                  VFFR_ST <= `Pop_VFF;
               else 
                  VFFR_ST <= `Rel_Bus;
            end
         `Rel_Bus:
            begin
               if(!TB_BG_VMER)
                  VFFR_ST <= `VR_idle;
               else 
                  VFFR_ST <= `Rel_Bus;
            end
         default:
            VFFR_ST <= `VR_idle;
      endcase
end

always @(VFFR_ST or VFF_MT or VD1 or EOP_RD)
begin
   case (VFFR_ST)
      `Pop_VFF:
         POP <= !VFF_MT && !(VD1 && EOP_RD);
      default:
         POP <= 0;
   endcase
end
always @(VFFR_ST)
begin
   case (VFFR_ST)
      `VR_idle,`Rel_Bus:
         VMER_BR <= 0;
      default:
         VMER_BR <= 1;
   endcase
end
always @(VFFR_ST)
begin
   case (VFFR_ST)
      `GbE_Send:
         begin
            SEND_PKT <= 1;
         end
      default:
         begin
            SEND_PKT <= 0;
         end
   endcase
end

always @(posedge CLK)
begin
   if(VMER_OE)
      DATA_OUT <= VFF_OUT;
   else
      DATA_OUT <= 16'hZZZZ;
end
always @(posedge CLK)
begin
   VD1 <= POP;
end

always @(posedge CLK)
begin
   if(VLDT_RD)
      case (PKT_TYP_RD)
         `Norm_Pkt:
            begin
               NORM_DAT <= VD1;
               PRIO_DAT <= 0;
               SPONT_DAT <= 0;
            end
         `INTR_Pkt,`INFO_Pkt,`WARN_Pkt,`ERR_Pkt:
            begin
               NORM_DAT <= 0;
               PRIO_DAT <= 0;
               SPONT_DAT <= VD1;
            end
         default:
            begin
               NORM_DAT <= VD1;
               PRIO_DAT <= 0;
               SPONT_DAT <= 0;
            end
      endcase
   else
      begin
         NORM_DAT <= 0;
         PRIO_DAT <= 0;
         SPONT_DAT <= 0;
      end
end

always @(posedge CLK)
begin
   if(VLDT_RD && VD1)
      case (PKT_TYP_RD)
         `Norm_Pkt:
            TXTYPE <= {6'b000001,DATA_SIZE[1:0]};  // 00 - F7 normal packet data types
         `INTR_Pkt:
            TXTYPE <= 8'hF8 | DATA_SIZE[1:0];
         `INFO_Pkt:
            TXTYPE <= 8'hFD;
         `WARN_Pkt:
            TXTYPE <= 8'hFE;
         `ERR_Pkt:
            TXTYPE <= 8'hFF;
         default:
            TXTYPE <= {6'b000001,DATA_SIZE[1:0]};
      endcase
   else
      TXTYPE <= TXTYPE;
end

always @(posedge CLK or posedge RST)
begin
   if(RST)
      SEND_PKT_TYP <= 0;
   else
      if(EOP_RD && VD1)
         SEND_PKT_TYP <= PKT_TYP_RD;
      else
         SEND_PKT_TYP <= SEND_PKT_TYP;
end

always @(SEND_PKT or SEND_PKT_TYP)
begin
   case (SEND_PKT_TYP)
      `Norm_Pkt:
         begin
            SEND_NORM <= SEND_PKT;
            SEND_PRIO <= 0;
            SEND_SPONT <= 0;
         end
      `INTR_Pkt,`INFO_Pkt,`WARN_Pkt,`ERR_Pkt:
         begin
            SEND_NORM <= 0;
            SEND_PRIO <= 0;
            SEND_SPONT <= SEND_PKT;
         end
      default:
         begin
            SEND_NORM <= SEND_PKT;
            SEND_PRIO <= 0;
            SEND_SPONT <= 0;
         end
   endcase
end

endmodule
